#include "module_meta_date_changed.h"
#include"area_business_person_attendance.h"
#include"area_business_car_attendance.h"

#include"common_tool.h"
#include "websocket/wsClientMgr.h"
#include"db/db_api/CDBSingletonDefine.h"
#include"event.h"

#include"ant.h"
#include"card.h"
#include"area.h"


///基础数据
void module_meta_date_changed::accept(sio::message::ptr const& data)
{
    std::string name="";
    if(!tool_map::try_get_value(name, JSON_KEY_NAME, data))
    {
        log_error("web发来的数据: 基础数据找不到name字段");
        return;
    }

    std_debug("基础数据 receive meta_data_changed: %s", name.c_str());

    int64_t id=-1;
    tool_map::try_get_value(id, JSON_KEY_ID, data);

    std::string op_type="";
    tool_map::try_get_value(op_type, JSON_KEY_OP_TYPE, data);

    if(-1 != id && !op_type.empty())
    {
        EDIT_TYPE_ID edit_type_id;
        if(!try_get_edit_type_id(op_type, edit_type_id))
        {
            log_error("web发来的数据: 基础数据op_type字段错误：op_type=%s", op_type.c_str());
            return;
        }

        if(JSON_KEY_NAME_VEHICLE == name || JSON_KEY_NAME_VEHICLE_EXTEND == name)
        {
            deal_call_edit_vehicle(id, edit_type_id);
        }
        else if(JSON_KEY_NAME_STAFF == name || JSON_KEY_NAME_STAFF_EXTEND == name)
        {
            deal_call_edit_staff(id, edit_type_id);
        }
        else if(JSON_KEY_NAME_CARD == name)
        {
            deal_call_edit_card(id, edit_type_id);
        }
        else if(JSON_KEY_NAME_AREA == name)
        {
            deal_call_edit_area(id, edit_type_id);
        }
        else if(JSON_KEY_NAME_READER == name)
        {
            deal_call_edit_reader(id, edit_type_id);
        }
        else if ("antenna" == name)
        {
            deal_call_edit_antenna(id,edit_type_id);
        }
        else if(JSON_KEY_NAME_PATH == name)
        {
            deal_call_edit_path(id, edit_type_id);
        }
        else if(JSON_KEY_NAME_MAP == name)
        {
            deal_call_edit_map(id, edit_type_id);
        }
        else if (JSON_KEY_NAME_LIGHT == name)
        {
            deal_call_edit_light(id,edit_type_id);///待实现
        }
        else if ("lights_group" == name)
        {
            deal_call_edit_lights_group(id,edit_type_id);///待实现
        }
        else
        {
            log_error("web发来的数据: 基础数据name字段错误：name=%s", name.c_str());
        }
    }
    else
    {
        if(JSON_KEY_NAME_SETTING == name)
        {
            //阈值限制接口
            init_setting(); ///待实现
        }
        else
        {
            log_error("web发来的数据: 基础数据name字段错误：name=%s", name.c_str());
        }
    }
}

///3.清除卡相关信息，区域相关，分站相关，考勤相关，清除定时器，
///速度，状态 呼救 呼叫 告警相关。即保留基础信息，其他的重置。
void module_meta_date_changed::clear_card(std::shared_ptr<card_location_base> card_ptr)
{
    auto rea_tool = card_ptr->get_area_tool();
    rea_tool->on_leave(card_ptr);
    //card_ptr->clear();

    //    //删除
    //    //card_ptr->del_card_pos();
    // 升井 删除所有报警信息
    for(int i=0; i < CARD_EVENT_COUNT_MAX; i++ )
    {
        if (i == EVENT_TYPE::ET_CARD_LOW_POWER_SERIOUS)
        {
            continue;
        }

        uint64_t id = tool_other::type_id_to_u64(card_ptr->m_type, card_ptr->m_id);
        event_tool::instance()->handle_event(OT_CARD, static_cast<EVENT_TYPE>(i), id, 0, 0, false);

        //        auto ev_ptr = event_list::instance()->get_event_card(
        //                card_ptr->m_id, card_ptr->m_type, static_cast<EVENT_TYPE>(i));
        //        if(ev_ptr && !ev_ptr->is_end()) //
        //        {
        //            event_list::copy_event(card_ptr, ev_ptr);

        //            ev_ptr->m_status = ES_END;

        //            event_list::save_event(ev_ptr);
        //        }
    }
}


void module_meta_date_changed::deal_call_edit_vehicle(int64_t id64, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        card_list::instance()->init_vehicle(id64);
    }
    else if(ET_DELETE == edit_type_id)
    {
        auto str = tool_other::to13str(id64);

        remove_card(tool_other::id64_to_id(str), tool_other::id64_to_type(str));
    }
}

void module_meta_date_changed::deal_call_edit_staff(int64_t id64, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        card_list::instance()->init_staffer(id64);
    }
    else if(ET_DELETE == edit_type_id)
    {
        auto str = tool_other::to13str(id64);

        remove_card(tool_other::id64_to_id(str), tool_other::id64_to_type(str));
    }
}

void module_meta_date_changed::deal_call_edit_card(int64_t id64, EDIT_TYPE_ID edit_type_id)
{
    std::string card_id64_str = tool_other::to13str(static_cast<uint64_t>(id64));
    int type = tool_other::id64_to_type(card_id64_str);

    if(tool_other::is_person(type))
    {
        deal_call_edit_staff(id64, edit_type_id);
    }
    else if(tool_other::is_vehicle(type))
    {
        deal_call_edit_vehicle(id64, edit_type_id);
    }
    else
    {
        log_error("基础数据 删除卡type不对：type=%d", type);
    }
}

void module_meta_date_changed::deal_call_edit_area(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        if(is_monkeycar_area(id))
        {
            area_list::instance()->init_monkeycar_area(id);
        }
        else
        {
            area_list::instance()->init_from_db(id);
        }
    }
    else if(ET_DELETE == edit_type_id)
    {
        auto area_ptr = area_list::instance()->get(id);
        if(!area_ptr)
        {
            log_info("区域已经删除：areaid=%d", id);
            return;
        }
        //删除告警
        delete_area_event(area_ptr);
        area_list::instance()->remove(id);
    }
}

void module_meta_date_changed::deal_call_edit_reader(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        sit_list::instance()->init_site(id);
    }
    else if(ET_DELETE == edit_type_id)
    {
        //删除告警

        sit_list::instance()->remove(id);
    }
}

void module_meta_date_changed::deal_call_edit_antenna(int id,EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        sit_list::instance()->read_sit_list(id);
    }
    else if(ET_DELETE == edit_type_id)
    {
        delete_antenna(id);
    }
}

void module_meta_date_changed::deal_call_edit_path(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id)
    {
        log_error("path不支持增加操作");
        std_debug("path不支持增加操作");
    }
    else if(ET_UPDATE == edit_type_id)
    {
        sit_list::instance()->read_ant_path(id);
    }
    else if(ET_DELETE == edit_type_id)
    {
        auto sit_ptr = sit_list::instance()->get(id);
        if(sit_ptr)
        {
            sit_ptr->clear_path();
        }

        log_info("path删除成功，分站id=%d", id);
        std_debug("path删除成功，分站id=%d", id);
    }
}

void module_meta_date_changed::deal_call_edit_map(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
        if(!is_cur_map(id))
        {
            log_info("修改的不是当前使用的地图，要修改地图id=%d，当前使用地图id=%d", id, cur_map_id());
            return;
        }

        update_map_info(id);
    }
    else if(ET_DELETE == edit_type_id)
    {
        if(is_cur_map(id))
        {
            log_error("删除了当前使用的地图");
            return;
        }
    }
}

void module_meta_date_changed::deal_call_edit_light(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
    }
    else if(ET_DELETE == edit_type_id)
    {
    }
}

void module_meta_date_changed::deal_call_edit_lights_group(int id, EDIT_TYPE_ID edit_type_id)
{
    if(ET_INSERT == edit_type_id || ET_UPDATE == edit_type_id)
    {
    }
    else if(ET_DELETE == edit_type_id)
    {
    }
}

void module_meta_date_changed::init_setting()
{
    //pRes = getMysqlRes("select setting_id, name, type, value from dat_setting;");
}

void module_meta_date_changed::remove_card(uint32_t id, int32_t type)
{
    uint64_t card_id = tool_other::type_id_to_u64(type, id);
    auto card_ptr = card_list::instance()->get(card_id);
    if(!card_ptr)
    {
        log_error("基础数据, 在全局列表中删除卡，全局列表中已经不存在此卡, id=%d, type=%d", id, type);
        return;
    }

    //    auto area_hover_ptr = card_ptr->get_area_hover();
    //    if(area_hover_ptr && 0!=area_hover_ptr->id() && 0!=area_hover_ptr->mapid())
    //    {
    //        module_area::on_leave(card_ptr->m_id, area_hover_ptr, card_ptr->m_type);
    //    }

    //    if(card_ptr->is_person())
    //    {
    //        module_attendance_person::up_mine(card_ptr, nullptr);
    //    }
    //    else
    //    {
    //        module_attendance_vehicle::save_attendance(card_ptr, nullptr);

    //        module_meta_date_changed::clear_card(card_ptr);
    //    }

    module_meta_date_changed::clear_card(card_ptr);
    // 避免状态重置
    card_list::instance()->remove(card_id);
    log_info("基础数据, 在全局列表中删除卡成功, id=%d, type=%d", id, type);
}

bool module_meta_date_changed::try_get_edit_type_id(const std::string& op_type, EDIT_TYPE_ID& out_edit_type_id)
{
    if(JSON_KEY_OP_TYPE_UPDATE == op_type)
    {
        out_edit_type_id = ET_UPDATE;
    }
    else if(JSON_KEY_OP_TYPE_DELETE == op_type)
    {
        out_edit_type_id = ET_DELETE;
    }
    else if(JSON_KEY_OP_TYPE_INSERT == op_type)
    {
        out_edit_type_id = ET_INSERT;
    }
    else
    {
        return false;
    }

    return true;
}

bool module_meta_date_changed::is_monkeycar_area(int area_id)
{
    char sql[1024] = {'\0'};
    sprintf(sql,"select monkeycar_areaid from dat_monkeycar_base_info where monkeycar_areaid=%d;", area_id);
    std::string Error;
    YADB::CDBResultSet DBRes;
    sDBConnPool.Query(sql,DBRes,Error);
    int64_t nCount = DBRes.GetRecordCount( Error );

    log_info("monkeycar_area区域查询：nCount=%d,sql=%s", nCount, sql);
    std_debug("monkeycar_area区域查询：nCount=%d,sql=%s", nCount, sql);

    return  (nCount > 0);
}

///删除区域所有报警信息
void module_meta_date_changed::delete_area_event(std::shared_ptr<area> area_ptr)
{
    for(int i=0; i < CARD_EVENT_COUNT_MAX; i++ )
    {
        event_tool::instance()->handle_event(OT_AREA, static_cast<EVENT_TYPE>(i), area_ptr->id(), 0, 0, false);
    }
}

void module_meta_date_changed::delete_antenna(int id)
{
    int sitid=-8;
    auto map = sit_list::instance()->m_map;
    for(auto&it:map)
    {
        auto sit_ptr = it.second;
        if(sit_ptr->m_ant[0].m_id == id)
        {
            sitid=sit_ptr->m_id;
            sit_ptr->delete_antenna(0);
            break;
        }
        if(sit_ptr->m_ant[1].m_id == id)
        {
            sitid=sit_ptr->m_id;
            sit_ptr->delete_antenna(1);
            break;
        }
    }

    if(sitid==-8)
    {
        std_debug("天线已经删除了，在分站列表中找不到该天线：天线id=%d", id);
        log_info("天线已经删除了，在分站列表中找不到该天线：天线id=%d", id);
    }
    else
    {
        std_debug("删除天线成功：天线id=%d，分站id=%d", id, sitid);
        log_info("删除天线成功：天线id=%d，分站id=%d", id, sitid);
    }
}

bool module_meta_date_changed::is_cur_map(int id)
{
    return cur_map_id()==id;
}

int module_meta_date_changed::cur_map_id()
{
    auto tmp = area_list::instance()->m_map;
    for(auto&it:tmp)
    {
        if(0!=it.second->m_mapid)
        {
            return it.second->m_mapid;
        }
    }

    return -1;
}

void module_meta_date_changed::update_map_info(int id)
{
    std::string sql = "SELECT scale FROM dat_map WHERE map_id=";

    sql.append(std::to_string(id));
    sql.append(";");

    std_debug("修改地图 sql=%s", sql.c_str());
    log_info("修改地图 sql=%s", sql.c_str());

    std::string Error;
    YADB::CDBResultSet DBRes;
    sDBConnPool.Query(sql.c_str(),DBRes,Error);
    int nCount = DBRes.GetRecordCount( Error );
    if (nCount < 1)
    {
        log_error("修改地图失败，数据库中找不到: map_id=%d", id);
        return ;
    }

    double scale  = 0;
    DBRes.GetField( "scale",scale, Error );

    auto area = area_list::instance()->m_map;
    for(auto& it : area)
    {
        it.second->m_scale = scale;
    }

    auto site = sit_list::instance()->m_map;
    for(auto& it : site)
    {
        it.second->m_scale = scale;
    }
}
